#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include "../src/exception.h"
#include "../src/verbose.h"
#include "../src/taf/generic.h"
#include "../src/game.h"

int main(int argc, char **argv) {	
	la_taf_t taf;
	la_tas_t tas;
	la_char_io_t cio;
	la_verbose_init_fp(stderr);
	la_verbose_channel_add(Action, Verbose, &la_verbose_fatal_channel);

	la_taf_init(&taf);
	la_char_io_init(&cio, "standard output");
	try {
		la_taf_parse_fp(&taf, stdin, "standard input");
		la_char_filter_push(&cio, "fpout", stdout);
		la_tas_init(&tas, &taf, &cio, &cio);
		la_game_restart(&tas);
		la_tas_write_file(&tas, "out.tas");
	}
	endtry;

	la_char_io_free(&cio);
	la_taf_free(&taf);
	la_verbose_free();

	exit(0);
}
