/* Example program to show off some of the highlevel capabilities of 
 * libadrift, it undoes the behaviour of salvage.c 
 *
 * This program is in the Public Domain (PD) 2004, Rik Snel
 */
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include "../src/verbose.h"
#include "../src/exception.h"
#include "../src/taf/generic.h"

int main(int argc, char **argv) {	
	la_taf_t taf;


	if (argc != 1) {
		fprintf(stderr, 
"This program accepts an (un)obfuscated .TAF file in standard input\n"
"and it will send the obfuscated version to stdout\n"
"If the incoming .TAF file doesn't have a password, the password of the\n"
"outgoing .TAF file will consist of ASCII NUL characters. (untypable?)\n"
"\n"
"Usage: %s < INFILE > OUTFILE\n", argv[0]);
		exit(1);
	}

	//la_verbose_init_fp_quiet(&v); /* shut up warnings */
	la_verbose_init_fp(stderr); 
	if (atexit(la_verbose_free)) {
		fprintf(stderr, "fatal error\n");
		exit(1);
	}

	la_taf_init(&taf);

	try {
		la_exception_cleanup_adda(taf, &la_taf_free);
		la_taf_parse_fp(&taf, stdin, "standard input");
		la_taf_write_fp(&taf, stdout, "standard output", 0);
	}
	endtry;

	exit(0);
}
