/* array.h - interface for handling dynamic arrays
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: array.h 366 2004-03-14 17:27:24Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_ARRAY_H
#define INCLUDE_LIBADRIFT_ARRAY_H 1
#include <setjmp.h>

#define la_array_sinit(a,b,c,d)	\
	la_array_init(a, (void*)&b.c, &b.no_##c, sizeof(*b.c), d)
#define la_array_ninit(a,b,c)	\
	la_array_init(a, (void*)&b, &no_##b, sizeof(*b), c)
#define la_array_push(a,b)	la_array_insert(a, b, *(a)->no_objects)
#define la_array_last(a)	la_array_get(a, *(a)->no_objects - 1)
#define la_array_pop(a,b)	la_array_delete(a, b, *(a)->no_objects - 1)
#define LA_ARRAY_STRERR_LEN	70

typedef struct {
	void **objects;
	int *no_objects;
	int size;
	void (*freer)(void*);
	char strerr[LA_ARRAY_STRERR_LEN];
} la_array_t;

void la_array_init(la_array_t*, void**, int*, int, void (*)());

void la_array_free(la_array_t*);

void la_array_empty(la_array_t*);

void *la_array_get(la_array_t*, int);

void *la_array_insert(la_array_t*, void*, int);

void la_array_delete(la_array_t*, void*, int);

#endif /* INCLUDE_LIBADRIFT_ARRAY_H */
