/* autoclean.h - C++ like autoclean, based on info from
 * http://ldeniau.home.cern.ch/ldeniau/html/exception/exception.html
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: autoclean.h 366 2004-03-14 17:27:24Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_AUTOCLEAN_H
#define INCLUDE_LIBADRIFT_AUTOCLEAN_H 1
#include <assert.h>

typedef struct la_autoclean_s {
	struct la_autoclean_s *next;
	void *ptr;
	void (*freer)(void*);
} la_autoclean_t;

la_autoclean_t la_autoclean_add(la_autoclean_t**, la_autoclean_t*, 
		void*, void (*)(void*)); 

void la_autoclean_all(la_autoclean_t*);

#endif /* INCLUDE_LIBADRIFT_AUTOCLEAN_H */
