/* cex_lex.l - simple lexer for calculating simple C expressions
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: cex_lex.l 366 2004-03-14 17:27:24Z rsnel $
 */
%{
#include "cex_parse.h"
#define YY_DECL int cex_lex(YYSTYPE *yylval_param, YYLTYPE *yylloc_param, \
                yyscan_t yyscanner)

extern YY_DECL;
//%option outfile="cex_lex.c" header-file="cex_lex.h"
%}
%option header-file="cex_lex.h"
%option bison-bridge reentrant bison-locations 
%option noyywrap nounput
%%

[[:digit:]]+	{ yylval->num = atoi(yytext); return NUMBER; }
==		{ return EQ; }
!=		{ return NEQ; }
\<=		{ return SM_EQ; }
\>=		{ return BG_EQ; }
&&		{ return AND; }
"||"		{ return OR; }
"<<"		{ return SHL; }
">>"		{ return SHR; }
[ \t]
.|\n		{ return yytext[0]; }

%%

