/* line_in.h - interface for handling (out of order) line input from .TAF files
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: line_in.h 424 2004-03-29 08:25:27Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_LINE_IN_H
#define INCLUDE_LIBADRIFT_LINE_IN_H 1

#include <stdarg.h>
#include <setjmp.h>
#include "verbose.h"
#include "intstack.h"
#include "char_io.h"

typedef struct {
	la_char_io_t *cin;
	la_intstack_t intstack;
	int in_line_no, spaceint;
	char line_no[256];
} la_line_in_t;

void la_line_in_init(la_line_in_t*, la_char_io_t*, int);

void la_line_in_free(la_line_in_t*);

void la_line_in_space(la_line_in_t*);

char *la_line_in_get_string(la_line_in_t*);

void la_line_in_skip(la_line_in_t*);

int la_line_in_get_int(la_line_in_t*);

void la_line_in_break_compound(la_line_in_t*, int, int, ...);

void la_line_in_push(la_line_in_t*, int);

void la_line_in_pop(la_line_in_t*, int);

void la_line_in_fakeint(la_line_in_t*, int);

void la_line_in_fakestring(la_line_in_t*, char*);

#endif /* INCLUDE_LIBADRIFT_LINE_IN_H */

