/* objcache.h - interface for caching object properties
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: objcache.h 462 2004-04-03 22:31:26Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_OBJCACHE_H
#define INCLUDE_LIBADRIFT_OBJCACHE_H 1

#include "taf/generic.h"

typedef struct {
	int surface;
	int revsurface;
	int container;
	int revcontainer;
	int chairlike;
	int revchairlike;
	int bedlike;
	int revbedlike;
	int clothing;
	int revclothing;
	int stateful;
	int revstateful;
	int dynamic;
	int revdynamic;
} la_objcache_elt_t;

typedef struct {
	la_objcache_elt_t *elts;
	int no_elts;
} la_objcache_t;

void la_objcache_init(la_taf_t*);

void la_objcache_free(la_taf_t*);

#endif /* INCLUDE_LIBADRIFT_OBJCACHE_H */
