/* object.h - info about objects
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: object.h 458 2004-04-03 14:21:51Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_OBJECT_H
#define INCLUDE_LIBADRIFT_OBJECT_H 1

#include "taf/generic.h"

#define is_container(a) 	(a)->is_container
#define is_surface(a) 		(a)->is_surface
#define is_clothing(a) 		(a)->is_clothing
#define is_chairlike(a) 	(a)->is_chairlike
#define is_bedlike(a)		(a)->is_bedlike
#define is_stateful(a)		(a)->start_state || (a)->open_info.type
#define is_dynamic(a)		!(a)->is_static

#define RF(a)			(((la_taf_room_t*)tas->taf->data.rooms.ptr) + a)
#define RS(a)			(((la_tas_room_t*)tas->data.rooms.ptr) + a)
#define OF(a)			(((la_taf_object_t*)tas->taf->data.objects.ptr) + a)
#define OS(a)			(((la_tas_object_t*)tas->data.objects.ptr) + a)
#define CF(a)			(((la_taf_character_t*)tas->taf->data.characters.ptr) + a)
#define CS(a)			(((la_tas_character_t*)tas->data.characters.ptr) + a)

#endif /* INCLUDE_LIBADRIFT_OBJECT_H */
