/* resolve.h - interface for resolving objects 
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: resolve.h 464 2004-04-04 23:13:16Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_RESOLVE_H
#define INCLUDE_LIBADRIFT_RESOLVE_H 1

#include "taf/generic.h"
#include "objcache.h"

void la_resolve_object_f(la_taf_t*, la_taf_object_spec_t*);

void la_resolve_player_roomlocation(la_tas_t*, la_array_t*);

void la_resolve_character_roomlocation(la_tas_t*, la_array_t*, int);

void la_resolve_person_roomlocation(la_tas_t*, la_array_t*, la_taf_person_spec_t*);

void la_resolve_object_roomlocation(la_tas_t*, la_array_t*, int);

void la_resolve_static_roomlocation(la_tas_t*, la_array_t*, la_taf_static_location_t*);

void la_resolve_dynamic_roomlocation(la_tas_t*, la_array_t*, la_taf_definite_dynamic_location_t*);

void la_resolve_all_held_objects(la_tas_t*, la_array_t*);

void la_resolve_all_worn_objects(la_tas_t*, la_array_t*);

void la_resolve_all_objects_in_container(la_tas_t*, la_array_t*, int);

void la_resolve_all_objects_on_surface(la_tas_t*, la_array_t*, int);

void la_resolve_object(la_tas_t*, la_array_t*, la_taf_object_spec_t*);

void la_resolve_characters_in_room(la_tas_t*, la_array_t*, int);

void la_resolve_characters_in_same_room_as_player(la_tas_t*, la_array_t*);

void la_resolve_allowed_directions(la_tas_t*, la_array_t*);

void la_resolve_objects_directly_in_same_room_as_player(la_tas_t*, la_array_t*);

#endif /* INCLUDE_LIBADRIFT_RESOLVE_H */
