/* restriction.c - functions for restrictions on the gamestate
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: game.h 454 2004-04-01 19:45:12Z rsnel $
 */
#include "taf/generic.h"
#include "object.h"
#include "resolve.h"
#include "output.h"

#define LA_VERBOSE_TYPE Restriction

int la_restriction_character_in_room(la_tas_t *tas, int character, int room) {
	la_taf_person_location_t *loc = &CS(character)->location;
	if (loc->room.realtype == la_taf_room_spec_room_e) {
		if (loc->room.spec.room == room) return 1;
	}
	return 0;
}

int la_restriction_object_held_by_player(la_tas_t *tas, int i) {
	la_taf_dynamic_posture_t *post;
	if (!is_dynamic(OF(i))) return 0;
	post = &OS(i)->location.posture;
	if (post->realtype == la_taf_dynamic_posture_held_by_e) {
		if (post->spec.held_by.realtype == la_taf_person_spec_player_e) return 1;
	}
	return 0;
}

int la_restriction_object_worn_by_player(la_tas_t *tas, int i) {
	la_taf_dynamic_posture_t *post;
	if (!is_dynamic(OF(i))) return 0;
	post = &OS(i)->location.posture;
	if (post->realtype == la_taf_dynamic_posture_worn_by_e) {
		if (post->spec.worn_by.realtype == la_taf_person_spec_player_e) return 1;
	}
	return 0;
}

int la_restriction(la_tas_t *tas, la_taf_restriction_t *r) {
	return 0;
}
