/* slot.h - interface for flexible array parsing
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: slot.h 426 2004-03-29 08:47:15Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_SLOT_H
#define INCLUDE_LIBADRIFT_SLOT_H 1

#define LA_SLOT_MAX 10

typedef struct {
	int size;
	int fixed;
	char *name;
} la_slot_info_t;

int la_slot_total(la_slot_info_t[]); 

int la_slot_index(la_slot_info_t[], int);

void *la_slot_alloc(void*, la_slot_info_t[], int, int, int, int);

#endif /* INCLUDE_LIBADRIFT_SLOT_H */
