/* tas.h - interface for handling generic .TAS files
 *
 * Copyright (C) 2004 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: tas.h 464 2004-04-04 23:13:16Z rsnel $
 */
#ifndef INCLUDE_LIBADRIFT_TAS_H
#define INCLUDE_LIBADRIFT_TAS_H 1

#include "../verbose.h"
#include "../char_io.h"

#define LA_TAF_WUNOBFUSC 0x00000001
#define LA_TAF_WZLIBHIGH 0x00000002
#define LA_TAF_WNOPASSWD 0x00000004

#include "generic.h"
#include "free.h"
#include "copy.h"

struct la_tas_s {
	la_taf_t *taf;
	la_tas_data_t data;
	la_char_io_t *green;
	la_char_io_t *red;
	int refd_character;
	int refd_object;
	char *iam;
	char *i;
};

void la_tas_init(la_tas_t*, la_taf_t*, la_char_io_t*, la_char_io_t*);

void la_tas_free(la_tas_t*);

void la_tas_copy(la_tas_t*, la_tas_t*);

void la_tas_parse_char_io(la_tas_t*, la_char_io_t*);

void la_tas_parse_fp(la_tas_t*, FILE*, char*);

void la_tas_parse_file(la_tas_t*, char*);

void la_tas_write_char_io(la_tas_t*, la_char_io_t*);

void la_tas_write_fp(la_tas_t*, FILE*, char*);

void la_tas_write_file(la_tas_t*, char*);

#endif /* INCLUDE_LIBADRIFT_TAS_H */
