/* vim: set filetype=c cindent: spec - Public Domain 2004, Rik Snel
 *
 * --- PRELIMINARY VERSION --- PRELIMINARY VERSION --- PRELIMINARY VERSION ---
 *
 * This file documents in human and machine readable form the structure
 * of (currently only) .TAS files from ADRIFT 3.90. It can be used to generate 
 * include files, a parser, a writer, memory management and reporting  
 * functions related to the data in aforementioned .TAS files.
 *
 * The data in this file is based on work by Mark J. Tilford, who reverse
 * engineered the format for use in his jASEA application. Simon Baldwin
 * wrote the C program SCARE based on jASEA, from which I read off
 * the meaning of the numbers generally found in .TAS files.
 *
 * $Id: tas.spec 471 2004-07-18 10:47:34Z rsnel $ 
 */
stringexp(t->data.title);
exp(NO_ROOMS);
exp(NO_OBJECTS);
exp(NO_TASKS);
exp(NO_EVENTS);
exp(NO_CHARACTERS);
noneg(score);
sstruct(player, player) {
	fstruct(location, person_location, dyn) {
		compound("i-1", "i+1");
		fstruct(room, room_spec);
		iff(t->version > 380) {
			push(1);
			fstruct(posture, person_posture, tas) {
				kswitch() {
					fstruct(standing_on, object_spec, dyn_chair) {
						pop(1);
						compound("i+1", "i-1");
						kswitch() {
							legenda(the_floor);
							noneg(chairlike);
						}
					}
					fstruct(sitting_on, object_spec, dyn_chair);
					fstruct(lying_on, object_spec, dyn_bed) {
						pop(1);
						compound("i+1", "i-1");
						kswitch() {
							legenda(the_floor);
							noneg(bedlike);
						}
					}
				}
			}
		}
	}
	iff(t->version > 380) {
		fstruct(gender, person_gender);
	}
	noneg(size_capacity);
	noneg(current_size_carried);
	noneg(weight_capacity);
	noneg(current_weight_carried);
}
sloop(rooms, room, NO_ROOMS, 0) {
	boolean(visited);
}
sloop(objects, object, NO_OBJECTS, 0) {
	push(1);
	boolean(seen);
	pop(1);
	iff(FOBJ->is_static) {
		exp(-1);
		exp(-1);
	}
	eliff(!FOBJ->is_static) {
		/* yes, this is ugly... */
		compound(i>0?i+1:i==-1?1:0, i>1?i-1:i==1?-1:0, i==0?1:i==-10?2:i==-20?3:i==-100?4:i==-200?5:i==-300?6:0, i==1?0:i==2?-10:i==3?-20:i==4?-100:i==5?-200:i==6?-300:0);
		fstruct(location, definite_dynamic_location, dyn) {
			fstruct(room, room_spec, unspec);
			fstruct(posture, dynamic_posture, dyn) {
				kswitch() {
					exp(-1);
					legenda(around);
					fstruct(held_by, person_spec, player_exp) {
						exp(0, -1);
						legenda(spec.player);
					}
					fstruct(in, object_spec, direct) {
						noneg(spec.direct);
					}
					fstruct(on, object_spec, direct);
					fstruct(held_by, person_spec, player_exp);
					fstruct(held_by, person_spec, character) {
						noneg(spec.character);
					}
					fstruct(worn_by, person_spec, character);
				}
			}
		}
	}
	iff(FOBJ->open_info.type) {
		space();
		iff(tas->taf->version >= 400) {
			compound(i-5, i+5);
		}
		eliff(tas->taf->version < 400) {
			compound(6-i, 6-i);
		}
		fstruct(open_state, open_state, dyn) {
			kswitch() {
				legenda(open);
				legenda(closed);
				legenda(locked);
			}
		}
	}
	iff(tas->taf->version >= 400) {
		/* should be some 400 stuff, 3.90 is first priority  */
	}
}
sloop(tasks, task, NO_TASKS, 0) {
	boolean(completed);
	boolean(scored);
}
sloop(events, event, NO_EVENTS, 0) {
	noneg(time);
	noneg(task);
	noneg(state);
	boolean(task_done);
}
sloop(characters, character, NO_CHARACTERS, 0) {
	fstruct(location, person_location, modc);
	boolean(seen);
}
sloop(variables, variable, NO_VARIABLES, 0) {
	intg(value);
}
noneg(time);
noneg(turns);
